
#include <math.h>
#include <allegro.h>
#include "CBloob.h"

char bloob_blender[256][256];


CBloob::CBloob(int diameter, int from_col, int to_col) {
	bmp = create_bitmap(diameter, diameter);
	upper = to_col;
	lower = from_col;
	int dist = upper-lower;
	dx = rand()%40/10.0+1;
	dy = rand()%50/10.0;
	a_matt = (int)(diameter * 0.07);
	int a,b;

	if (bmp != NULL) {
		//generate bloob
		for(int y=0;y<diameter;y++)
			for(int x=0;x<diameter;x++) {
				int dx = x - diameter / 2;
				int dy = y - diameter / 2;
				float k = 1 - sqrt(dx*dx+dy*dy) * 2 / diameter;
			    if (k < 0) k = 0;
				unsigned char c = (unsigned char)MAX(dist * k * k, 0);
				// unsigned char c = (unsigned char)MAX(dist * k, 0);
				bmp->line[x][y] = c;
			}

	}
}

CBloob::~CBloob() {
	if (bmp != NULL) destroy_bitmap(bmp);
}

void CBloob::setupBlender() {
	int a, b;

	// setup blender
	for(a=0;a<256;a++)
		for(b=0;b<256;b++)
			bloob_blender[a][b] = MIN(a+b, upper);
}

void CBloob::draw(BITMAP *dest_bmp) {
	int v,u;
	ix = (int)x;
	iy = (int)y;

	// add bloob to bitmap
    for(v=a_matt;v<bmp->h-a_matt;v++)
      for(u=a_matt;u<bmp->w-a_matt;u++)
		  dest_bmp->line[iy+v][ix+u] = bloob_blender[dest_bmp->line[iy+v][ix+u]][bmp->line[v][u]];
}
